# Benchmarking
We use [PkgBenchmark.jl](http://github.com/juliaCI/PkgBenchmark.jl) which can be
installed using `Pkg.add("PkgBenchmark")`.  To run the benchmarks:
```julia
using PkgBenchmark
results=benchmarkpkg("TeaSeis")
export_markdown("results.md", results)
```
In order to compare the benchmarks against a different version:
```julia
results=judge("TeaSeis", "e1d4076")
export_markdown("results.md", results)
```
where `e1d4076` is a Git SHA.  To run a specific benchmark:
```julia
benchmarks=include("benchmarks.jl")
run(benchmarks["Frame operations"]["write,Float32"])
```

You can profile a benchmark.  For example:
```julia
benchmarks=include("benchmarks.jl")
@profile run(benchmarks["Frame operations"]["write,Float32"])
```
Use `Profile.print()` and `using ProfileView; ProfileView.view()` to inspect the
profile.  Note that `ProfileView.view()` requires
[ProfileView.jl](http://github.com/timholy/ProfileView.jl).

For more information, please see the documentation for
[PkgBenchmark.jl](http://github.com/juliaCI/PkgBenchmark.jl) and
[BenchmarkTools.jl](https://github.com/JuliaCI/BenchmarkTools.jl).
